import { BbStorage } from '../core/services/storage.service';
import { BbJwt } from '../core/services/jwt.service';
import { BbApiConfig } from './api.interfaces';
import { BbApi } from './api.service';
export declare class BbAuth {
    private _jwt;
    private _api;
    private _storage;
    private _config;
    private readonly _apiUserStorageKey;
    private readonly _apiTokenStorageKey;
    private readonly _apiRefreshTokenStorageKey;
    private _user$;
    constructor(_jwt: BbJwt, _api: BbApi, _storage: BbStorage, _config: BbApiConfig);
    readonly isAuthenticated: boolean;
    readonly user: import("rxjs").Observable<{
        [key: string]: any;
    }>;
    readonly accessToken: any;
    readonly refreshToken: any;
    readonly payload: any;
    login(email: string, password: string): Promise<any>;
    logout(): void;
    refresh(): import("rxjs").Observable<any>;
    setTokens(token: string, refreshToken: string): void;
    setUser(user: object): void;
    clear(): void;
}
